## oce 0.15

=== CMakeLists.txt ===
# REQUIREMENTS: this script needs CMake 2.8 or higher. Downloads are available at http://www.cmake.org

# How to build OCE using CMake under Unix (Linux, Darwin etc.)?
# 1. Copy this file, as-is, to the top-level OCE folder
# 2. Make a build directory somewhere outside the OCE source tree
# 3. cmake "relative/path/to/OCE"
# 4. make
# 5. make install (or sudo make install)

# How to build OCE using CMake under Windows (Linux, Darwin etc.)?
# 1. Copy this file, as-is, to the top-level folder
# 2. Launch the cmake-gui, and select the top-level folder
# 3. You can choose whatever you want as an install directory
# 4. Click 'Configure'
# 5. Choose your generator
# 6. When configure is achived, you can change the variable with a red background
# 7. Click 'Generate'
# 8. From your IDE, open the generated makefile and run the compilation.

project(OCE)

set(OCE_VERSION_MAJOR 0)
set(OCE_VERSION_MINOR 15)
# OCE_VERSION_PATCH is used for bugfixes releases only
# (uncomment following line)
#set(OCE_VERSION_PATCH 0)
#  Empty for official releases, set to -dev, -rc1, etc for development releases
set(OCE_VERSION_DEVEL)

# bugfix release: add ${OCE_VERSION_PATCH} to OCE_VERSION
set(OCE_VERSION ${OCE_VERSION_MAJOR}.${OCE_VERSION_MINOR}${OCE_VERSION_DEVEL})

set(OCE_ABI_SOVERSION 8)
set(OCE_ABI_VERSION ${OCE_ABI_SOVERSION}.0.0)

# Set the minimum version of cmake required to 2.6
cmake_minimum_required( VERSION 2.6 )

# Define helper macro option_with_default
macro( option_with_default OPTION_NAME OPTION_STRING OPTION_DEFAULT )
	if( NOT DEFINED ${OPTION_NAME} )
		set( ${OPTION_NAME} ${OPTION_DEFAULT} )
	endif( NOT DEFINED ${OPTION_NAME} )
	option( ${OPTION_NAME} "${OPTION_STRING}" ${${OPTION_NAME}} )
endmacro( option_with_default OPTION_NAME OPTION_STRING OPTION_DEFAULT )

############################
# Check 32/64 bit platform #
############################
if (${CMAKE_SIZEOF_VOID_P} MATCHES "8") # It is 64bit, otherwise 32 bit systems match 4
	add_definitions(-D_OCC64)
	set(BIT 64)
else (${CMAKE_SIZEOF_VOID_P} MATCHES "8")
	set(BIT 32)
endif(${CMAKE_SIZEOF_VOID_P} MATCHES "8")

message(STATUS "Build ${BIT}bit")

if(NOT CMAKE_CONFIGURATION_TYPES)
	if( NOT DEFINED OCE_BUILD_TYPE )
    # If CMAKE_BUILD_TYPE is set, initialize OCE_BUILD_TYPE to that.
    # Otherwise, default to a Release build.
    if( CMAKE_BUILD_TYPE )
      set( OCE_BUILD_TYPE "${CMAKE_BUILD_TYPE}" CACHE STRING "Set from CMAKE_BUILD_TYPE" )
    else()
		  set( OCE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: Release Debug RelWithDebInfo MinSizeRel None" )
	    set( CMAKE_BUILD_TYPE ${OCE_BUILD_TYPE} CACHE INTERNAL "Build type, immutable" FORCE )
    endif(CMAKE_BUILD_TYPE)
	endif( NOT DEFINED OCE_BUILD_TYPE )
	#  The "set_property(CACHE" capability first appeared in CMake version 2.8.0
	#  We test against > 2.8 though, otherwise test is much less readable
	if (${CMAKE_VERSION} VERSION_GREATER 2.8)
		set_property(CACHE OCE_BUILD_TYPE PROPERTY STRINGS "Release" "Debug" "RelWithDebInfo" "MinSizeRel" "None")
	endif (${CMAKE_VERSION} VERSION_GREATER 2.8)
endif(NOT CMAKE_CONFIGURATION_TYPES)

if(CMAKE_BUILD_TOOL STREQUAL "nmake")
	set(NMAKE TRUE)
endif(CMAKE_BUILD_TOOL STREQUAL "nmake")

if(MSVC)
	option_with_default( OCE_INSTALL_PDB_FILES "Install PDB files (debug informations)" ON )
	option_with_default( OCE_MULTITHREADED_BUILD "Multithreaded build (/MP Option)" ON )
endif(MSVC)

############################
# Library name definitions #
############################

if(MSVC)
	set( OCE_LIBRARY_PREFIX "" )
	set( CMAKE_DEBUG_POSTFIX "d" )
else(MSVC)
	set( OCE_LIBRARY_PREFIX "lib" )
endif(MSVC)


if(APPLE)
	if(OCE_NO_LIBRARY_VERSION)
		set( OCE_LIBRARY_EXTENSION ${CMAKE_SHARED_LIBRARY_SUFFIX} )
	else(OCE_NO_LIBRARY_VERSION)
		set( OCE_LIBRARY_EXTENSION ".${OCE_ABI_SOVERSION}${CMAKE_SHARED_LIBRARY_SUFFIX}" )
	endif(OCE_NO_LIBRARY_VERSION)
elseif(WIN32)
	# Don't encode library versions on Windows systems
	set( OCE_LIBRARY_EXTENSION ${CMAKE_SHARED_LIBRARY_SUFFIX} )
else()
	if(OCE_NO_LIBRARY_VERSION)
		set( OCE_LIBRARY_EXTENSION ${CMAKE_SHARED_LIBRARY_SUFFIX} )
	else(OCE_NO_LIBRARY_VERSION)
		set( OCE_LIBRARY_EXTENSION "${CMAKE_SHARED_LIBRARY_SUFFIX}.${OCE_ABI_SOVERSION}" )
	endif(OCE_NO_LIBRARY_VERSION)
endif()

if(MSVC OR MINGW)
	option_with_default( OCE_USE_BUNDLE "Use OCE Windows Bundle that has been built and installed" OFF )
	option_with_default( OCE_USE_BUNDLE_SOURCE "Use OCE Windows Bundle source and incorporate into current project" OFF )
endif(MSVC OR MINGW)

if(BORLAND)
	option_with_default( OCE_INSTALL_TDS_FILES "Instal TDS files (debug informations)" ON )
endif(BORLAND)

if(OCE_USE_BUNDLE OR OCE_USE_BUNDLE_SOURCE)
	option_with_default( OCE_BUNDLE_AUTOINSTALL "Autoinstall bundle DLLs" ON )
	mark_as_advanced(OCE_BUNDLE_AUTOINSTALL)
endif(OCE_USE_BUNDLE OR OCE_USE_BUNDLE_SOURCE)

if ((MSVC AND NOT NMAKE) OR CMAKE_COMPILER_IS_GNUCXX)
	set(OCE_COMPILER_SUPPORTS_PCH TRUE)
	if(MSVC)
		option_with_default( OCE_USE_PCH "Use Precompiled Headers" ON )
	else()
		option_with_default( OCE_USE_PCH "Use Precompiled Headers" OFF )
	endif()
	mark_as_advanced(OCE_USE_PCH)
endif((MSVC AND NOT NMAKE) OR CMAKE_COMPILER_IS_GNUCXX)

option_with_default( OCE_BUILD_SHARED_LIB "Build shared OCE libs" ON )
if(NOT MSVC AND NOT OCE_OSX_USE_COCOA)
	option_with_default( OCE_DISABLE_X11 "Disable components requiring X11 support" OFF )
	if(NOT APPLE AND NOT WIN32)
		mark_as_advanced(OCE_DISABLE_X11)
	endif(NOT APPLE AND NOT WIN32)
endif(NOT MSVC AND NOT OCE_OSX_USE_COCOA)
option_with_default( OCE_MODEL "Build model components" ON )
option_with_default( OCE_OCAF "Build application framework" ON )
option_with_default( OCE_DATAEXCHANGE "Build data exchange" ON )
option_with_default( OCE_DRAW "Build test harness \(DRAW\)" OFF )
option_with_default( OCE_VISUALISATION "Build visualisation component" ON )
option_with_default( OCE_WITH_GL2PS "Build with GL2PS" OFF )
option_with_default( OCE_WITH_FREEIMAGE "Build with FreeImage" OFF )
option_with_default( OCE_EXTRA_WARNINGS "Enable Maximum Warnings Level" OFF )
mark_as_advanced(OCE_EXTRA_WARNINGS)
if( NOT "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" LESS 2.8 )
	option_with_default( OCE_TESTING "Enable unittesting framework" OFF )
	mark_as_advanced(OCE_TESTING)
endif( NOT "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" LESS 2.8 )
option_with_default( OCE_ADD_HEADERS "Add headers to project files" OFF )
mark_as_advanced(OCE_ADD_HEADERS)
option_with_default( OCE_DISABLE_BSPLINE_MESHER "Disable BSpline Mesher" OFF )
mark_as_advanced(OCE_DISABLE_BSPLINE_MESHER)
if(APPLE)
	option_with_default( OCE_OSX_USE_COCOA "Use native OSX Cocoa backend" ON )
endif(APPLE)
if (NOT WIN32)
	option_with_default( OCE_RPATH_FILTER_SYSTEM_PATHS "Filter out system paths from RPATH" ON )
	mark_as_advanced(OCE_RPATH_FILTER_SYSTEM_PATHS)
endif (NOT WIN32)
# When building OCE as part of another application, it may be useful to copy
# header files in a temporary location so that dependent applications can be built
option_with_default( OCE_COPY_HEADERS_BUILD "Copy header files when building OCE" OFF )

option_with_default( OCE_USE_TCL_TEST_FRAMEWORK "Add occt-tests target" OFF )

#
# By default, OSX uses X11 OpenGl implementation
#
if (APPLE)
	if (NOT OCE_OSX_USE_COCOA)
		set(MACOSX_USE_GLX TRUE)
	endif(NOT OCE_OSX_USE_COCOA)
endif(APPLE)
# The default for the DEB define is ON for all the platforms , in debug mode.
# In MSVC it is not desirable to have it ON by default, since users must
# compile/use the OCE debug libraries to build it's own programs in DEBUG mode.
# DEB should be enabled by developers only, in this case
if ((MSVC OR BORLAND) AND CMAKE_CONFIGURATION_TYPES)
	set (DEB_DEFAULT "OFF")
else ()
	set (DEB_DEFAULT "ON")
endif ((MSVC OR BORLAND) AND CMAKE_CONFIGURATION_TYPES)

option_with_default( OCE_ENABLE_DEB_FLAG "Enables DEB define in debug configuration" ${DEB_DEFAULT} )
mark_as_advanced(OCE_ENABLE_DEB_FLAG)

if(NOT MSVC)
	option_with_default( OCE_COVERAGE "Build with coverage testing" OFF )
	mark_as_advanced(OCE_COVERAGE)
endif(NOT MSVC)

if( NOT DEFINED OCE_MULTITHREAD_LIBRARY)
	set( OCE_MULTITHREAD_LIBRARY "NONE" CACHE STRING "(values are: NONE TBB OPENMP)" )
endif( NOT DEFINED OCE_MULTITHREAD_LIBRARY)

if (${CMAKE_VERSION} VERSION_GREATER 2.8)
	set_property(CACHE OCE_MULTITHREAD_LIBRARY PROPERTY STRINGS NONE TBB OPENMP)
endif (${CMAKE_VERSION} VERSION_GREATER 2.8)

option( OCE_MULTITHREAD_LIBRARY "Multithread library" ${OCE_MULTITHREAD_LIBRARY} )

if( OCE_MULTITHREAD_LIBRARY STREQUAL "TBB" )
	option_with_default( OCE_TBB_MALLOC_SUPPORT "Use TBB for memory allocation" ON )
endif( OCE_MULTITHREAD_LIBRARY STREQUAL "TBB" )

if( OCE_USE_TCL_TEST_FRAMEWORK )
	set( tcl_test_groups 3rdparty;blend;boolean;bugs;caf;chamfer;de;demo;draft;feat;geometry;heal;mesh;mkface;nproject;offset;perf;pipe;prism;sewing;thrusection;v3d;xcaf;xml )
	if( NOT DEFINED OCE_TCL_TEST_GROUP)
		set( OCE_TCL_TEST_GROUP "ALL" CACHE STRING "Group of OCCT test packages to run (values are: ALL;${tcl_test_groups})" )
	endif( NOT DEFINED OCE_TCL_TEST_GROUP)
	mark_as_advanced(OCE_TCL_TEST_GROUP)
	if (${CMAKE_VERSION} VERSION_GREATER 2.8)
		set_property(CACHE OCE_TCL_TEST_GROUP PROPERTY STRINGS "ALL;${tcl_test_groups}")
	endif (${CMAKE_VERSION} VERSION_GREATER 2.8)
endif( OCE_USE_TCL_TEST_FRAMEWORK )

if( NOT DEFINED OCE_INSTALL_PREFIX )
	if( WIN32 )
		set(OCE_INSTALL_PREFIX
			"c:/OCE-${OCE_VERSION}")
	else( WIN32 )
		set(OCE_INSTALL_PREFIX
			"/usr/local")
	endif( WIN32 )
endif( NOT DEFINED OCE_INSTALL_PREFIX )

set( OCE_INSTALL_PREFIX ${OCE_INSTALL_PREFIX} CACHE
	PATH "Install prefix prepended to target to create install location" )
set( CMAKE_INSTALL_PREFIX "${OCE_INSTALL_PREFIX}" CACHE INTERNAL "Prefix
	prepended to install directories if target destination is not absolute,
	immutable" FORCE )

if( OCE_BUILD_SHARED_LIB )
	set( OCE_LIBRARY_TYPE SHARED )
	set( OCE_BUILD_STATIC_LIB FALSE )
else( OCE_BUILD_SHARED_LIB )
	set( OCE_LIBRARY_TYPE STATIC )
	set( OCE_BUILD_STATIC_LIB TRUE )
	if ( WIN32 )
		add_definitions("-DHAVE_NO_DLL")
	endif( WIN32 )
endif( OCE_BUILD_SHARED_LIB )

# MSVC specific options
if(MSVC_IDE)
	if (NOT DEFINED OCE_USE_MSVC_EXPRESS )
		set (OCE_USE_MSVC_EXPRESS OFF)
	endif (NOT DEFINED OCE_USE_MSVC_EXPRESS)
	option( OCE_USE_MSVC_EXPRESS "Use a Visual C++ express IDE"
		${OCE_USE_MSVC_EXPRESS} )
endif(MSVC_IDE)

set_directory_properties(PROPERTIES COMPILE_DEFINITIONS_RELEASE NDEBUG)
set_directory_properties(PROPERTIES COMPILE_DEFINITIONS_MINSIZEREL NDEBUG)
set_directory_properties(PROPERTIES COMPILE_DEFINITIONS_RELWITHDEBINFO  NDEBUG)

if(OCE_ENABLE_DEB_FLAG)
	set_directory_properties(PROPERTIES COMPILE_DEFINITIONS_DEBUG "DEB=1;_DEBUG")
else ()
	set_directory_properties(PROPERTIES COMPILE_DEFINITIONS_DEBUG "_DEBUG")
endif (OCE_ENABLE_DEB_FLAG)

if(OCE_MULTITHREAD_LIBRARY STREQUAL "NONE")
    add_definitions(-DIGNORE_NO_ATOMICS)
endif (OCE_MULTITHREAD_LIBRARY STREQUAL "NONE")

#
# Check components dependencies
#
set(OCE_FOUNDATION TRUE)
if(OCE_OCAF OR OCE_DATAEXCHANGE OR OCE_VISUALISATION OR OCE_DRAW)
	set(OCE_VISU_DEP TRUE)
else(OCE_OCAF OR OCE_DATAEXCHANGE OR OCE_VISUALISATION OR OCE_DRAW)
	set(OCE_VISU_DEP FALSE)
endif(OCE_OCAF OR OCE_DATAEXCHANGE OR OCE_VISUALISATION OR OCE_DRAW)
if(OCE_DISABLE_X11)
	set(OCE_VISU_DEP FALSE)
endif(OCE_DISABLE_X11)
if(OCE_DISABLE_X11)
	set(OCE_DRAW OFF CACHE BOOL "Build DRAWEXE" FORCE)
	set(OCE_VISUALISATION OFF CACHE BOOL "Build visualisation component" FORCE)
endif(OCE_DISABLE_X11)

if(NOT OCE_BUILD_SHARED_LIB AND OCE_DRAW)
	set(OCE_DRAW OFF CACHE BOOL "Build DRAWEXE" FORCE)
	message("Warning : DRAW disabled when statically linking")
endif(NOT OCE_BUILD_SHARED_LIB AND OCE_DRAW)

if(OCE_DRAW AND NOT OCE_DATAEXCHANGE)
	set(OCE_DATAEXCHANGE ON CACHE BOOL "Build data exchange" FORCE)
endif(OCE_DRAW AND NOT OCE_DATAEXCHANGE)
if(OCE_DATAEXCHANGE AND NOT OCE_OCAF)
	set(OCE_OCAF ON CACHE BOOL "Build application framework" FORCE)
endif(OCE_DATAEXCHANGE AND NOT OCE_OCAF)

=== examples/find_package/CMakeLists.txt ===
# This example shows how to use find_package(OCE).
# If OCE is not found, try to find an OpenCascade installation.

cmake_minimum_required(VERSION 2.6)

find_package(OCE)
if(OCE_FOUND)
    message(STATUS "Found OCE version ${OCE_VERSION}")
    # Include files reside in ${OCE_INCLUDE_DIRS};
    include_directories(${OCE_INCLUDE_DIRS})
    # We do not need library path, they will be automatically imported.
else(OCE_FOUND)
    # OCE not found; either it is not found and user
    # has to set OCE_DIR to the directory containing
    # OCEConfig.cmake, or OCE is not installed and we
    # try to find OpenCascade files.
    if(DEFINED ENV{CASROOT})
        if(NOT DEFINED OCC_INCLUDE_PATH)
            set(OCC_INCLUDE_PATH "$ENV{CASROOT}/inc")
        endif(NOT DEFINED OCC_INCLUDE_PATH)
        if(NOT DEFINED OCC_LIB_PATH)
            if(WIN32)
                set(OCC_LIB_PATH "$ENV{CASROOT}/win32/lib")
            else(WIN32)
                if(APPLE)
                    set(OCC_LIB_PATH "/Library/OpenCASCADE/6.3.0/lib")
                else(APPLE)
                    set(OCC_LIB_PATH "$ENV{CASROOT}/lin/lib")
                endif(APPLE)
            endif(WIN32)
        endif(NOT DEFINED OCC_LIB_PATH)
    else(DEFINED ENV{CASROOT})
        if(NOT DEFINED OCC_INCLUDE_PATH OR NOT DEFINED OCC_LIB_PATH)
            message(WARNING "To specify paths of OpenCascade files, you may either define the CASROOT environment variable, or set both OCC_INCLUDE_PATH and OCC_LIB_PATH variables.")
        endif(NOT DEFINED OCC_INCLUDE_PATH OR NOT DEFINED OCC_LIB_PATH)
    endif(DEFINED ENV{CASROOT})
    if(DEFINED OCC_INCLUDE_PATH)
        message(STATUS "OCC search path for include files: OCC_INCLUDE_PATH=${OCC_INCLUDE_PATH}")
        include_directories(${OCC_INCLUDE_PATH})
    endif(DEFINED OCC_INCLUDE_PATH)
    if(DEFINED OCC_LIB_PATH)
        message(STATUS "OCC search path for libraries: OCC_LIB_PATH=${OCC_LIB_PATH}")
        link_directories(${OCC_LIB_PATH})
    endif(DEFINED OCC_LIB_PATH)
endif(OCE_FOUND)

add_executable(computeSurface computeSurface.cpp)
target_link_libraries(computeSurface TKPrim)

=== test/BRepImport_test/CMakeLists.txt ===
if (OCE_DATAEXCHANGE)
	set(brep_file_1 ${CMAKE_SOURCE_DIR}/test/data/brep/15_cylinder_head.brep)
	set(brep_file_2 ${CMAKE_SOURCE_DIR}/test/data/brep/27_leverarm.brep)
	set(brep_file_3 ${CMAKE_SOURCE_DIR}/test/data/brep/29_misc1.brep)
	set(brep_file_4 ${CMAKE_SOURCE_DIR}/test/data/brep/31_misc2.brep)

	configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/BRepImport_test_config.h.cmake ${CMAKE_BINARY_DIR}/test_inc/BRepImport_test_config.h )
	include_directories(${CMAKE_BINARY_DIR}/test_inc)

	add_oce_test(BRepImport_test "TKernel;TKSTEP")
endif (OCE_DATAEXCHANGE)

=== test/BRepOffsetAPI_test/CMakeLists.txt ===
if (OCE_MODEL)
	add_oce_test(BRepOffsetAPI_test "TKOffset")
endif (OCE_MODEL)

=== test/IGESImport_test/CMakeLists.txt ===
if (OCE_DATAEXCHANGE)
	set(iges_file_1 ${CMAKE_SOURCE_DIR}/test/data/IGES/hammer.igs)

	configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/IGESImport_test_config.h.cmake ${CMAKE_BINARY_DIR}/test_inc/IGESImport_test_config.h )
	include_directories(${CMAKE_BINARY_DIR}/test_inc)

	add_oce_test(IGESImport_test "TKernel;TKIGES")
endif (OCE_DATAEXCHANGE)

=== test/SortTools_test/CMakeLists.txt ===
add_oce_test(sorttools_test "TKernel")

=== test/gp_test/CMakeLists.txt ===
if (OCE_MODEL)
	add_oce_test(gp_test "TKG2d")
endif (OCE_MODEL)

=== adm/cmake/DRAWEXE/CMakeLists.txt ===
set(TOOLKIT_APP DRAWEXE)

set(TOOLKIT_APP_MODULES
	DRAWEXE
)
set(TOOLKIT_APP_LIBS
	TKDraw
	TKMesh
	TKTopAlgo
	TKHLR
	TKGeomAlgo
	TKGeomBase
	TKG2d
	TKBRep
	TKMath
	TKG3d
	TKernel
	TKService
)

message(STATUS "Processing application: ${TOOLKIT_APP} (${TOOLKIT_APP_MODULES})")
set(TOOLKIT_APP_SOURCE_FILES)
foreach(MODULE ${TOOLKIT_APP_MODULES})
	# add all .cxx/*.c files or each module
	file(GLOB source_files
		${OCE_SOURCE_DIR}/src/${MODULE}/*.cxx
		${OCE_SOURCE_DIR}/src/${MODULE}/*.c
		${OCE_SOURCE_DIR}/drv/${MODULE}/*.cxx
		${OCE_SOURCE_DIR}/drv/${MODULE}/*.c)
	#message(STATUS "${source_files}")
	foreach(module_source_file ${source_files})
		if (WIN32)
			# For compilers under Windows a define must be set per file to correctly set the export macro
			set_source_files_properties(${module_source_file} PROPERTIES COMPILE_FLAGS "-D__${MODULE}_DLL")
		endif(WIN32)
	endforeach(module_source_file ${source_files})

	# append these source files to the list of source files of the toolkit
	set(TOOLKIT_APP_SOURCE_FILES ${TOOLKIT_APP_SOURCE_FILES} ${source_files})
	# required include paths
	include_directories(${OCE_SOURCE_DIR}/src/${MODULE} ${OCE_SOURCE_DIR}/drv/${MODULE})
endforeach(MODULE ${TOOLKIT_APP_MODULES})
if(TOOLKIT_APP_LIBS)
	set(TOOLKIT_DEPENDS_INCLUDE_DIRECTORIES)
	foreach(tkit ${TOOLKIT_APP_LIBS})
		set(TOOLKIT_DEPENDS_INCLUDE_DIRECTORIES ${TOOLKIT_DEPENDS_INCLUDE_DIRECTORIES} ${OCE_${tkit}_INCLUDE_DIRECTORIES})
	endforeach(tkit ${TOOLKIT_APP_LIBS})
	list(REMOVE_DUPLICATES TOOLKIT_DEPENDS_INCLUDE_DIRECTORIES)
	include_directories(${TOOLKIT_DEPENDS_INCLUDE_DIRECTORIES})
endif(TOOLKIT_APP_LIBS)

# Version info
if(NOT OCE_NO_LIBRARY_VERSION)
	if(MSVC)
		set(TOOLKIT_RESOURCES ${OCE_WIN32_RES_FILE})
		add_definitions("-DOCE_VERSION_INFO_IS_EXE")
	endif(MSVC)
endif(NOT OCE_NO_LIBRARY_VERSION)

add_executable(${TOOLKIT_APP} ${TOOLKIT_APP_SOURCE_FILES} ${TOOLKIT_RESOURCES} )

set_target_properties_install_rpath(${TOOLKIT_APP} "${OCE_INSTALL_LIB_DIR_RPATH};${OCE_INSTALL_PACKAGE_LIB_DIR_RPATH}")

if(WIN32 AND (CMAKE_CONFIGURATION_TYPES OR NMAKE))
	set_target_properties(${TOOLKIT_APP} PROPERTIES
		DEBUG_OUTPUT_NAME ${TOOLKIT_APP}${CMAKE_DEBUG_POSTFIX}
	)
endif(WIN32 AND (CMAKE_CONFIGURATION_TYPES OR NMAKE))

# Set dependencies for thit ToolKit
list(REMOVE_DUPLICATES TOOLKIT_APP_LIBS)
target_link_libraries(${TOOLKIT_APP} ${TOOLKIT_APP_LIBS} ${WIN32_LIBS})

#  Those are private libraries
install(TARGETS ${TOOLKIT_APP}
	RUNTIME DESTINATION ${OCE_INSTALL_BIN_DIR}         COMPONENT RuntimeLibraries
	LIBRARY DESTINATION ${OCE_INSTALL_PACKAGE_LIB_DIR} COMPONENT RuntimeLibraries
	ARCHIVE DESTINATION ${OCE_INSTALL_PACKAGE_LIB_DIR} COMPONENT Development
)

=== adm/cmake/TKAdvTools/CMakeLists.txt ===
set(TOOLKIT TKAdvTools)

set(TOOLKIT_MODULES
	Dynamic
	Materials
	Expr
	ExprIntrp
	GraphDS
	GraphTools
)
set(TOOLKIT_DEPENDS
	TKernel
)

include(../BuildToolkit.cmake)

=== adm/cmake/TKBO/CMakeLists.txt ===
set(TOOLKIT TKBO)

set(TOOLKIT_MODULES
	IntTools
	BRepAlgoAPI
	BOPCol
	BOPInt
	BOPDS
	BOPAlgo
	BOPTools
)
set(TOOLKIT_DEPENDS
	TKBRep
	TKTopAlgo
	TKMath
	TKernel
	TKG2d
	TKG3d
	TKGeomAlgo
	TKGeomBase
)

include(../BuildToolkit.cmake)

=== adm/cmake/TKBRep/CMakeLists.txt ===
set(TOOLKIT TKBRep)

set(TOOLKIT_MODULES
	TopoDS
	TopExp
	TopTools
	BRep
	BRepLProp
	BRepAdaptor
	BRepTools
)
set(TOOLKIT_DEPENDS
	TKMath
	TKernel
	TKG2d
	TKG3d
	TKGeomBase
)

include(../BuildToolkit.cmake)

=== adm/cmake/TKDCAF/CMakeLists.txt ===
set(TOOLKIT TKDCAF)

set(TOOLKIT_MODULES
	DDF
	DDocStd
	DNaming
	DDataStd
	DPrsStd
	DrawDim
)
set(TOOLKIT_DEPENDS TKCAF
	TKGeomBase
	TKBRep
	TKGeomAlgo
	TKernel
	TKMath
	TKG2d
	TKG3d
	TKDraw
	TKCDF
	TKV3d
	TKNIS
	TKService
	TKLCAF
	TKFillet
	TKTopAlgo
	TKPrim
	TKBool
	TKBO
	TKCAF
	TKViewerTest
)

set(TOOLKIT_IS_PRIVATE TRUE)

include(../BuildToolkit.cmake)

=== debian/changelog ===
oce (0.15-4) unstable; urgency=medium

  * Fix multiarch: move oce-config.h into /usr/include/<triplet>.
    Closes: #739558.

 -- Denis Barbier <barbier@debian.org>  Mon, 03 Mar 2014 09:49:43 +0100

oce (0.15-3) unstable; urgency=medium

  * debian/rules: fix CMAKE_BUILD_TYPE.
  * debian/control: add Build-Depends: libfreetype-dev
  * debian/control: add various Depends in liboce-*-dev packages, since
    libraries are referenced in CMake files shipped by these packages.

 -- Denis Barbier <barbier@debian.org>  Thu, 20 Feb 2014 17:12:23 +0100

oce (0.15-2) unstable; urgency=medium

  * Upload into unstable.
  * debian/patches/include-oce-config.patch: New patch, to fix
    header files so that programs building against OCE do not
    need to pass -DHAVE_CONFIG_H flag.

 -- Denis Barbier <barbier@debian.org>  Wed, 19 Feb 2014 01:01:20 +0100

oce (0.15-1) experimental; urgency=medium

  * Package official OCE 0.15 release.
  * debian/copyright: Update, several files were missing.

 -- Denis Barbier <barbier@debian.org>  Thu, 13 Feb 2014 23:36:32 +0100

oce (0.15~pre1-1) experimental; urgency=medium

  * New upstream version.
  * Relicensed to LGPL 2.1.  Closes: #736249

 -- Denis Barbier <barbier@debian.org>  Sun, 09 Feb 2014 22:40:39 +0100

oce (0.14.1-1) experimental; urgency=medium

  * New upstream version.
  * debian/patches/fix-FTBFS-armel.patch: Patch dropped, applied
    upstream.
  * debian/control: remove Build-Depends: libftgl-dev, FTGL is no
    more used.
  * debian/control: add Build-Depends: libfreeimage-dev, it was
    missing.
  * debian/control: Bump Standards-Version to 3.9.5.

 -- Denis Barbier <barbier@debian.org>  Mon, 03 Feb 2014 17:31:57 +0100

oce (0.13-4) experimental; urgency=low

  * debian/rules: pass -DFREETYPE_INCLUDE_DIR_freetype2=/usr/include/freetype2
    option to CMake in order to workaround bug #731089.  This allows
    building with Freetype 2.4 and 2.5.

 -- Denis Barbier <barbier@debian.org>  Mon, 02 Dec 2013 21:37:22 +0100

oce (0.13-3) experimental; urgency=low

  * testMeshTorus test timeouts on mips when building package; make
    this test perform less checks in order to avoid this timeout.

 -- Denis Barbier <barbier@debian.org>  Sat, 30 Nov 2013 18:55:04 +0100

oce (0.13-2) experimental; urgency=low

  * debian/patches/NCollection-align-64bit.patch: New patch, to align
    words on 64 bit.  This fixes FTBFS on mips, mipsel and sparc.
  * debian/patches/fix-FTBFS-armel.patch: New patch, to fix FTBFS
    on armel.

 -- Denis Barbier <barbier@debian.org>  Tue, 26 Nov 2013 21:59:30 +0100

oce (0.13-1) experimental; urgency=low

  * New upstream version, SONAME bumped.
  * debian/patches/fix-Hurd.patch: Patch dropped, applied
    upstream.

 -- Denis Barbier <barbier@debian.org>  Mon, 23 Sep 2013 19:41:32 +0200

oce (0.12-4) unstable; urgency=low

  * debian/patches/split-export.patch: Fix find_package(oce) by
    loading 'visualization' targets before 'ocaf' ones.  This
    command currently spits out with this message:
      The following imported targets are referenced, but are missing:
        TKV3d TKService TKV2d
  * debian/control: Also let liboce-ocaf-dev depend on liboce-visualization-dev.

 -- Denis Barbier <barbier@debian.org>  Wed, 07 Aug 2013 22:47:40 +0200

=== debian/control ===
Source: oce
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>, Denis Barbier <barbier@debian.org>
Standards-Version: 3.9.5
Build-Depends: debhelper (>= 9), quilt, cmake,
 libx11-dev, libxmu-dev, libxext-dev, libfreetype6-dev, tcl8.5-dev, tk8.5-dev,
 libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev,
 libgl2ps-dev, libfreeimage-dev
Homepage: https://github.com/tpaviot/oce/wiki
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/oce.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/oce.git -b debian

Package: liboce-foundation8
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform shared library
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package is based on OCE, OpenCASCADE Community Edition, which is
 maintained by a community of developers, and not by OpenCASCADE SAS.
 .
 This package contains foundation classes which provide a variety of
 general-purpose services such as automated management of heap memory,
 exception handling, classes for manipulating aggregates of data, basic
 math tools.
 .
 This package contains the following shared libraries:
   TKernel TKMath TKAdvTools

Package: liboce-modeling8
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform shared library
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package is based on OCE, OpenCASCADE Community Edition, which is
 maintained by a community of developers, and not by OpenCASCADE SAS.
 .
 This package supplies data structures to represent 2D and 3D geometric models,
 as well as topological and geometrical algorithms.
 .
 This package contains the following shared libraries:
   TKG2d TKG3d TKGeomBase TKBRep TKGeomAlgo TKTopAlgo TKPrim TKBO TKHLR
   TKMesh TKShHealing TKXMesh TKBool TKFillet TKFeat TKOffset TKSTL
   TKXSBase TKSTEPBase TKIGES TKSTEPAttr TKSTEP209 TKSTEP

Package: liboce-visualization8
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform shared library
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package is based on OCE, OpenCASCADE Community Edition, which is
 maintained by a community of developers, and not by OpenCASCADE SAS.
 .
 This package provides services for displaying 2D and 3D graphics.
 .
 This package contains the following shared libraries:
   TKService TKV2d TKV3d TKOpenGl TKMeshVS TKNIS TKVRML TKVoxel

Package: liboce-ocaf-lite8
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform shared library
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package is based on OCE, OpenCASCADE Community Edition, which is
 maintained by a community of developers, and not by OpenCASCADE SAS.
 .
 This package is part of the OpenCASCADE Application Framework, it
 provides shared libraries which have no dependency against X11.
 .
 This package contains the following shared libraries:
   TKCDF PTKernel TKLCAF FWOSPlugin TKPShape TKBinL TKXmlL
   TKPLCAF TKTObj TKShapeSchema TKStdLSchema

Package: liboce-ocaf8
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform shared library
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package is based on OCE, OpenCASCADE Community Edition, which is
 maintained by a community of developers, and not by OpenCASCADE SAS.
 .
 This package provides OpenCASCADE Application Framework services and 
 support for data exchange.
 .
 This package contains the following shared libraries:
   TKCAF TKBin TKXml TKPCAF TKBinTObj TKXmlTObj TKStdSchema
   TKXCAF TKXCAFSchema TKXmlXCAF TKBinXCAF TKXDEIGES TKXDESTEP

Package: oce-draw
Architecture: any
Section: science
Depends: ${shlibs:Depends}, ${misc:Depends},
 libx11-dev, libfreetype6-dev, tcl8.5-dev, tk8.5-dev
Replaces: opencascade-draw
Conflicts: opencascade-draw
Description: OpenCASCADE Community Edition CAE platform shared library
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package is based on OCE, OpenCASCADE Community Edition, which is
 maintained by a community of developers, and not by OpenCASCADE SAS.
 .
 This package contains the DRAW test harness.

Package: liboce-foundation-dev
Architecture: any
Section: libdevel
Depends: liboce-foundation8 (>= ${source:Upstream-Version}), liboce-foundation8 (<< ${source:Upstream-Version}+1~),
         ${misc:Depends}
Replaces: libopencascade-foundation-dev
Conflicts: libopencascade-foundation-dev
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform library development files
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package contains the headers and symlinks for libraries shipped by
 liboce-foundation8.

Package: liboce-modeling-dev
Architecture: any
Section: libdevel
Depends: liboce-foundation-dev (>= ${source:Upstream-Version}), liboce-foundation-dev (<< ${source:Upstream-Version}+1~),
         liboce-modeling8 (>= ${source:Upstream-Version}), liboce-modeling8 (<< ${source:Upstream-Version}+1~),
         ${misc:Depends}
Replaces: libopencascade-modeling-dev
Conflicts: libopencascade-modeling-dev
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform library development files
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package contains the headers and symlinks for libraries shipped by
 liboce-modeling8.

Package: liboce-ocaf-lite-dev
Architecture: any
Section: libdevel
Depends: liboce-foundation-dev (>= ${source:Upstream-Version}), liboce-foundation-dev (<< ${source:Upstream-Version}+1~),
         liboce-modeling-dev (>= ${source:Upstream-Version}), liboce-modeling-dev (<< ${source:Upstream-Version}+1~),
         liboce-ocaf-lite8 (>= ${source:Upstream-Version}), liboce-ocaf-lite8 (<< ${source:Upstream-Version}+1~),
         ${misc:Depends}
Replaces: libopencascade-ocaf-lite-dev
Conflicts: libopencascade-ocaf-lite-dev
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform library development files
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package contains the headers and symlinks for libraries shipped by
 liboce-ocaf-lite8.

Package: liboce-ocaf-dev
Architecture: any
Section: libdevel
Depends: liboce-foundation-dev (>= ${source:Upstream-Version}), liboce-foundation-dev (<< ${source:Upstream-Version}+1~),
         liboce-modeling-dev (>= ${source:Upstream-Version}), liboce-modeling-dev (<< ${source:Upstream-Version}+1~),
         liboce-ocaf-lite-dev (>= ${source:Upstream-Version}), liboce-ocaf-lite-dev (<< ${source:Upstream-Version}+1~),
         liboce-visualization-dev (>= ${source:Upstream-Version}), liboce-visualization-dev (<< ${source:Upstream-Version}+1~),
         liboce-ocaf8 (>= ${source:Upstream-Version}), liboce-ocaf8 (<< ${source:Upstream-Version}+1~),
         ${misc:Depends}
Replaces: libopencascade-ocaf-dev
Conflicts: libopencascade-ocaf-dev
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform library development files
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package contains the headers and symlinks for libraries shipped by
 liboce-ocaf8.

Package: liboce-visualization-dev
Architecture: any
Section: libdevel
Depends: liboce-foundation-dev (>= ${source:Upstream-Version}), liboce-foundation-dev (<< ${source:Upstream-Version}+1~),
         liboce-modeling-dev (>= ${source:Upstream-Version}), liboce-modeling-dev (<< ${source:Upstream-Version}+1~),
         liboce-ocaf-lite-dev (>= ${source:Upstream-Version}), liboce-ocaf-lite-dev (<< ${source:Upstream-Version}+1~),
         liboce-visualization8 (>= ${source:Upstream-Version}), liboce-visualization8 (<< ${source:Upstream-Version}+1~),
         libx11-dev, libxmu-dev, libxext-dev, libfreetype6-dev,
         libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev,
         libgl2ps-dev, libfreeimage-dev,
         ${misc:Depends}
Replaces: libopencascade-ocaf-lite-dev
Conflicts: libopencascade-ocaf-lite-dev
Multi-Arch: same
Description: OpenCASCADE Community Edition CAE platform library development files
 OpenCASCADE is a suite for 3D surface and solid modeling, visualization, data
 exchange and rapid application development.  It is an excellent platform for
 development of numerical simulation software including CAD/CAM/CAE, AEC and
 GIS, as well as PDM applications.
 .
 This package contains the headers and symlinks for libraries shipped by
 liboce-visualization8.

=== debian/rules ===
#!/usr/bin/make -f

CFLAGS   := $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS := $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifeq ($(findstring parallel=,$(DEB_BUILD_OPTIONS)),)
	export DEB_BUILD_OPTIONS+=parallel=$(shell getconf _NPROCESSORS_ONLN)
endif

%:
	dh $@ --buildsystem=cmake --parallel --with quilt

override_dh_auto_configure:
	# See in debian/patches/split-export.patch why we must ignore cmake return value
	-dh_auto_configure -- \
        -DFREETYPE_INCLUDE_DIR_freetype2=/usr/include/freetype2 \
        -DOCE_BUILD_SHARED_LIB:BOOL=ON \
        -DOCE_TESTING:BOOL=ON \
        -DOCE_USE_TCL_TEST_FRAMEWORK:BOOL=ON \
        -DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
        -DOCE_INSTALL_PREFIX:PATH=/usr \
        -DOCE_INSTALL_LIB_DIR:PATH=lib/$(DEB_HOST_MULTIARCH) \
        -DOCE_INSTALL_CMAKE_DATA_DIR:PATH=lib/$(DEB_HOST_MULTIARCH)/oce-0.15 \
        -DOCE_DRAW:BOOL=ON \
        -DOCE_RPATH_FILTER_SYSTEM_PATHS:BOOL=ON \
        -DCMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES:STRING='/lib/$(DEB_HOST_MULTIARCH);/usr/lib/$(DEB_HOST_MULTIARCH)' \
        -DCMAKE_C_FLAGS_RELWITHDEBINFO:STRING='$(CFLAGS)' \
        -DCMAKE_CXX_FLAGS_RELWITHDEBINFO:STRING='$(CXXFLAGS)' \
        -DCMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(LDFLAGS)' \
        -DCMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(LDFLAGS)' \
        -DOCE_MULTITHREAD_LIBRARY:STRING=NONE \
        -DOCE_WITH_FREEIMAGE:BOOL=ON \
        -DOCE_WITH_GL2PS:BOOL=ON \
        -DDART_TESTING_TIMEOUT:STRING='3600'

override_dh_auto_install:
	dh_auto_install
	-mkdir debian/tmp/usr/include/oce/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/include/oce/oce_build_config.defs debian/tmp/usr/include/oce/$(DEB_HOST_MULTIARCH)/oce_build_config.defs
	-mkdir debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/include/oce/oce-config.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/
	# Improve integration in Debian desktop
	install -d debian/tmp/usr/share/applications
	cp -p debian/oce-draw.desktop debian/tmp/usr/share/applications/
	install -d debian/tmp/usr/share/pixmaps
	cp -p debian/occ-icon-32.xpm debian/tmp/usr/share/pixmaps/
	install -d debian/tmp/usr/share/man/man1
	# Install manual page
	cp -p debian/DRAWEXE.1 debian/tmp/usr/share/man/man1/
	find debian/tmp/usr/share -name FILES -exec rm -f {} \;

override_dh_install:
	dh_install --list-missing
	rm -rf debian/oce-draw/usr/include

override_dh_makeshlibs:
	dh_makeshlibs -Noce-draw
